/** \mainpage Driver Overview
  *
  * \section section_drv_info Driver Information
  * This Sensor Controller Interface driver has been generated by the Texas Instruments Sensor Controller
  * Studio tool:
  * - <b>Project name</b>:     I2C HDC2010 Sensor for CC1352P with separare DIO for I2C Pullup ONOFF
  * - <b>Project file</b>:     C:/Users/a0797195/workspace_v92/CC1352P1_SCE_BASSENSORS/sce/HDC2010_TMP116_CC1352P_I2C_PullUpOff.scp
  * - <b>Code prefix</b>:      -
  * - <b>Operating system</b>: TI-RTOS
  * - <b>Tool version</b>:     2.5.0.84
  * - <b>Tool patches</b>:     1, 2 and 3
  * - <b>Target chip</b>:      CC1352P1F3, package QFN48 7x7 RGZ, revision E (2.1)
  * - <b>Created</b>:          2019-12-02 09:02:09.960
  * - <b>Computer</b>:         LTA0797195A
  * - <b>User</b>:             a0797195
  *
  * The following user-provided resource definition(s) were used to generate this driver
  * - <b>Timer</b>: C:/Users/a0797195/Documents/Texas Instruments/Sensor Controller Studio/resource_defs/timer.red
  *
  * The following user-provided procedure definition(s) were used to generate this driver
  * - <b>evhSetupCompaTrigger()</b>: C:/Users/a0797195/Documents/Texas Instruments/Sensor Controller Studio/proc_defs/evh_setup_compa_trigger.prd
  * - <b>timerStart()</b>: C:/Users/a0797195/Documents/Texas Instruments/Sensor Controller Studio/proc_defs/timer_start.prd
  * - <b>timerStop()</b>: C:/Users/a0797195/Documents/Texas Instruments/Sensor Controller Studio/proc_defs/timer_stop.prd
  * - <b>timerWait()</b>: C:/Users/a0797195/Documents/Texas Instruments/Sensor Controller Studio/proc_defs/timer_wait.prd
  *
  * Do not edit the generated source code files other than temporarily for debug purposes. Any
  * modifications will be overwritten by the Sensor Controller Studio when generating new output.
  *
  * \section section_drv_modules Driver Modules
  * The driver is divided into three modules:
  * - \ref module_scif_generic_interface, providing the API for:
  *     - Initializing and uninitializing the driver
  *     - Task control (for starting, stopping and executing Sensor Controller tasks)
  *     - Task data exchange (for producing input data to and consume output data from Sensor Controller
  *       tasks)
  * - \ref module_scif_driver_setup, containing:
  *     - The AUX RAM image (Sensor Controller code and data)
  *     - I/O mapping information
  *     - Task data structure information
  *     - Driver setup data, to be used in the driver initialization
  *     - Project-specific functionality
  * - \ref module_scif_osal, for flexible OS support:
  *     - Interfaces with the selected operating system
  *
  * It is possible to use output from multiple Sensor Controller Studio projects in one application. Only
  * one driver setup may be active at a time, but it is possible to switch between these setups. When
  * using this option, there is one instance of the \ref module_scif_generic_interface and
  * \ref module_scif_osal modules, and multiple instances of the \ref module_scif_driver_setup module.
  * This requires that:
  * - The outputs must be generated using the same version of Sensor Controller Studio
  * - The outputs must use the same operating system
  * - The outputs must use different source code prefixes (inserted into all globals of the
  *   \ref module_scif_driver_setup)
  *
  *
  * \section section_project_info Project Description
  * Demonstrates use of the bit-banged I2C master interface by sampling the HDC2010 sensor on
  * BOOSTXL-BASSENSORS with the CC1352P LaunchPad. The application wakes up periodically and reads out
  * the HDC2010, BAS BOOSTXL is not inserted but uses jumper wires to LP.
  * Each iteration of the HDC2010 Sensor task:
  * - Runs the Execution Code:  The timer based event trigger is enabled.
  * - Runs the Event Handler Code: The HDC is configured and the measurement is started, HDC values are
  * read and processed.
  * The HDC values are calculated into Decimal format, 40 x 16-bits BUFFER is used for the raw values.
  *
  *
  * \subsection section_io_mapping I/O Mapping
  * Task I/O functions are mapped to the following pins:
  * - HDC2010 Sensor:
  *     - <b>O: powers HDC2010 sensor</b>: DIO24
  *     - <b>O: Powers Pullup Resistors only on demand</b>: DIO19
  *     - <b>O: PullUP DRV pin to disable DRV5055 sensor</b>: DIO26
  *     - <b>I2C SCL</b>: DIO21
  *     - <b>I2C SDA</b>: DIO5
  *
  *
  * \section section_task_info Task Description(s)
  * This driver supports the following task(s):
  *
  *
  * \subsection section_task_desc_hdc2010_sensor HDC2010 Sensor
  * Samples the HDC2010 on the BASSENSORS BoostXL
  * 
  * Each iteration of the HDC2010 Sensor task:
  * - Runs the Execution Code: The HDC is configured and the measurement is started. The timer based
  * event trigger is enabled
  * - Runs the Event Handler Code: The HDC values are read and processed.
  * 
  * The HDC values are calculated into Decimal format, 40 x 16-bits BUFFER is used for the raw values.
  *
  */




/** \addtogroup module_scif_driver_setup Driver Setup
  *
  * \section section_driver_setup_overview Overview
  *
  * This driver setup instance has been generated for:
  * - <b>Project name</b>:     I2C HDC2010 Sensor for CC1352P with separare DIO for I2C Pullup ONOFF
  * - <b>Code prefix</b>:      -
  *
  * The driver setup module contains the generated output from the Sensor Controller Studio project:
  * - Location of task control and scheduling data structures in AUX RAM
  * - The AUX RAM image, and the size the image
  * - Task data structure information (location, size and buffer count)
  * - I/O pin mapping translation table
  * - Task resource initialization and uninitialization functions
  * - Hooks for run-time logging
  *
  * @{
  */
#ifndef SCIF_H
#define SCIF_H

#include <stdint.h>
#include <stdbool.h>
#include "scif_framework.h"
#include "scif_osal_tirtos.h"


/// Target chip name
#define SCIF_TARGET_CHIP_NAME_CC1352P1F3
/// Target chip package
#define SCIF_TARGET_CHIP_PACKAGE_QFN48_7X7_RGZ

/// Number of tasks implemented by this driver
#define SCIF_TASK_COUNT 1

/// HDC2010 Sensor: Task ID
#define SCIF_HDC2010_SENSOR_TASK_ID 0


/// HDC2010 Sensor: Buffer for 20 Temp + 20 HUM values
#define SCIF_HDC2010_SENSOR_BUFFER_SIZE 40
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_AMM_SET 38
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_DATA_INT 7
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_HUM_HIGH 3
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_HUM_LOW 2
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_I2C_ADDR 128
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_MODE_CFG 14
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_REG_DEVID_H 255
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_REG_DEVID_L 254
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_REG_MANID_H 253
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_REG_MANID_L 252
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_TMP_HIGH 1
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC2010_TMP_LOW 0
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_HDC201_MEASR_CFG 15
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_TEST 567
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_TMP116_CFG_SHUTDOWN 1568
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_TMP116_I2C_ADDR 144
/// HDC2010 Sensor: Reg CFG address
#define SCIF_HDC2010_SENSOR_TMP116_REG_CFG 1
/// HDC2010 Sensor: RegisterID (contains x116)
#define SCIF_HDC2010_SENSOR_TMP116_REG_ID 15
/// HDC2010 Sensor: Register Address for Temperature Result 
#define SCIF_HDC2010_SENSOR_TMP116_REG_RESULT 0
/// HDC2010 Sensor: 
#define SCIF_HDC2010_SENSOR_TMP_CFG_ONE_SHOT_8AVG 3104
/// HDC2010 Sensor I/O mapping: powers HDC2010 sensor
#define SCIF_HDC2010_SENSOR_DIO_O_HDC2010_PWR 24
/// HDC2010 Sensor I/O mapping: Powers Pullup Resistors only on demand
#define SCIF_HDC2010_SENSOR_DIO_O_VDD_PULLUP 19
/// HDC2010 Sensor I/O mapping: PullUP DRV pin to disable DRV5055 sensor
#define SCIF_HDC2010_SENSOR_DIO_O_DRV_UPP 26
/// HDC2010 Sensor I/O mapping: I2C SCL
#define SCIF_HDC2010_SENSOR_DIO_I2C_SCL 21
/// HDC2010 Sensor I/O mapping: I2C SDA
#define SCIF_HDC2010_SENSOR_DIO_I2C_SDA 5


// All shared data structures in AUX RAM need to be packed
#pragma pack(push, 2)


/// HDC2010 Sensor: Task configuration structure
typedef struct {
    uint16_t highThreshold;     ///< High alert threshold
    uint16_t lowThreshold;      ///< Low alert threshold
    uint16_t minReportInterval; ///< 
} SCIF_HDC2010_SENSOR_CFG_T;


/// HDC2010 Sensor: Task output data structure
typedef struct {
    uint16_t head;          ///< 
    uint16_t humDecimalPct; ///< 
    uint16_t humValue;      ///< 
    uint16_t pBuffer[40];   ///< Buffer for Temp+Hum 16-bit entries
    uint16_t tmpDecimalC;   ///< 
    uint16_t tmpValue;      ///< Light sensor output value
} SCIF_HDC2010_SENSOR_OUTPUT_T;


/// HDC2010 Sensor: Task state structure
typedef struct {
    uint16_t i2cStatus;              ///< I2C master status
    uint16_t samplesSinceLastReport; ///< The number of samples since last report was sent
} SCIF_HDC2010_SENSOR_STATE_T;


/// Sensor Controller task data (configuration, input buffer(s), output buffer(s) and internal state)
typedef struct {
    struct {
        SCIF_HDC2010_SENSOR_CFG_T cfg;
        SCIF_HDC2010_SENSOR_OUTPUT_T output;
        SCIF_HDC2010_SENSOR_STATE_T state;
    } hdc2010Sensor;
} SCIF_TASK_DATA_T;

/// Sensor Controller task generic control (located in AUX RAM)
#define scifTaskData    (*((volatile SCIF_TASK_DATA_T*) 0x400E015C))


// Initialized internal driver data, to be used in the call to \ref scifInit()
extern const SCIF_DATA_T scifDriverSetup;


// Restore previous struct packing setting
#pragma pack(pop)


// AUX I/O re-initialization functions
void scifReinitTaskIo(uint32_t bvTaskIds);


// RTC-based tick generation control
void scifStartRtcTicks(uint32_t tickStart, uint32_t tickPeriod);
void scifStartRtcTicksNow(uint32_t tickPeriod);
void scifStopRtcTicks(void);


#endif
//@}


// Generated by LTA0797195A at 2019-12-02 09:02:09.960
