/*
 *  ======== ti_drivers_config.h ========
 *  Configured TI-Drivers module declarations
 *
 *  DO NOT EDIT - This file is generated for the CC1352P1_LAUNCHXL
 *  by the SysConfig tool.
 */
#ifndef ti_drivers_config_h
#define ti_drivers_config_h

#define CONFIG_SYSCONFIG_PREVIEW

#define CONFIG_CC1352P1_LAUNCHXL

#ifndef DeviceFamily_CC13X2
#define DeviceFamily_CC13X2
#endif

#include <ti/devices/DeviceFamily.h>

#include <stdint.h>

/* support C++ sources */
#ifdef __cplusplus
extern "C" {
#endif


/*
 *  ======== GPIO ========
 */

/* DIO7, LaunchPad LED Green */
#define CONFIG_GPIO_7               0
/* DIO24 */
#define CONFIG_GPIO_24              1
/* DIO26 */
#define CONFIG_GPIO_26              2

/* LEDs are active high */
#define CONFIG_GPIO_LED_ON  (1)
#define CONFIG_GPIO_LED_OFF (0)

#define CONFIG_LED_ON  (CONFIG_GPIO_LED_ON)
#define CONFIG_LED_OFF (CONFIG_GPIO_LED_OFF)


/*
 *  ======== I2C ========
 */

/*
 *  SCL: DIO21
 *  SDA: DIO5
 */
#define CONFIG_I2C_0                0

/* ======== I2C Addresses and Speeds ======== */
#include <ti/drivers/I2C.h>

/* ---- CONFIG_I2C_0 I2C bus components ---- */

/* no components connected to CONFIG_I2C_0 */

/* max speed unspecified, defaulting to 100 Kbps */
#define CONFIG_I2C_0_MAXSPEED   (100U) /* Kbps */
#define CONFIG_I2C_0_MAXBITRATE ((I2C_BitRate)I2C_100kHz)


/*
 *  ======== PIN ========
 */

/* Includes */
#include <ti/drivers/PIN.h>

/* Externs */
extern const PIN_Config BoardGpioInitTable[];

/* Parent Signal: CONFIG_I2C_0 SDA, (DIO5) */
#define CONFIG_PIN_0    0x00000005
/* Parent Signal: CONFIG_I2C_0 SCL, (DIO21) */
#define CONFIG_PIN_1    0x00000015
/* Parent Signal: CONFIG_GPIO_24 GPIO Pin, (DIO24) */
#define CONFIG_PIN_3    0x00000018
/* Parent Signal: CONFIG_GPIO_26 GPIO Pin, (DIO26) */
#define CONFIG_PIN_4    0x0000001a
/* CONFIG_RF_24GHZ (DIO28) */
#define CONFIG_RF_24GHZ    0x0000001c
/* CONFIG_RF_HIGH_PA (DIO29) */
#define CONFIG_RF_HIGH_PA    0x0000001d
/* CONFIG_RF_SUB1GHZ (DIO30) */
#define CONFIG_RF_SUB1GHZ    0x0000001e
/* LaunchPad LED Green, Parent Signal: CONFIG_GPIO_7 GPIO Pin, (DIO7) */
#define CONFIG_PIN_2    0x00000007


/*
 *  ======== RF ========
 */
#define Board_DIO_30_RFSW 0x0000001e


/*
 *  ======== Board_init ========
 *  Perform all required TI-Drivers initialization
 *
 *  This function should be called once at a point before any use of
 *  TI-Drivers.
 */
extern void Board_init(void);

/*
 *  ======== Board_initGeneral ========
 *  (deprecated)
 *
 *  Board_initGeneral() is defined purely for backward compatibility.
 *
 *  All new code should use Board_init() to do any required TI-Drivers
 *  initialization _and_ use <Driver>_init() for only where specific drivers
 *  are explicitly referenced by the application.  <Driver>_init() functions
 *  are idempotent.
 */
#define Board_initGeneral Board_init

#ifdef __cplusplus
}
#endif

#endif /* include guard */
